<template>
  <div id="app">
    <Header v-if="screen" @takeappointment="takeappointment" />
    <TakeAppointment
      v-if="screen === 'TakeAppointment'"
      @emitvalidemail="validemail"
      @registrarme="registrarme"
    />
    <SignUp v-if="screen === 'SignUp'" @accept="singing" />
    <ReserveAppointment
      v-if="screen === 'ReserveAppointment'"
      :user1="arrayuser1"
      @confermappointment="reservenewmappointment"
      @button-delete="deleteUser"
      @button-edit="editUser"
    />
    <EditAppointment
      v-if="screen === 'EditAppointment'"
      :user1="userSelected"
      @btn-conferm-edit="confermeditUser"
    />
    <HomePage v-if="screenHome" />
    <Footer />
  </div>
</template>
<script>
import Header from "@/components/Header.vue";
import TakeAppointment from "@/components/TakeAppointment.vue";
import ReserveAppointment from "@/components/ReserveAppointment.vue";
import SignUp from "@/components/SignUp.vue";
import HomePage from "@/components/HomePage.vue";
import EditAppointment from "@/components/EditAppointment.vue";
import Footer from "@/components/Footer.vue";
import api from "@/api.js";
export default {
  name: "App",
  data() {
    return {
      URL1: "/api/user1",
      URL2: "http://localhost:3000/user2",
      screen: "Header",
      screenHome: true,
      userId: null,
      completeURL: "",
      arrayuser1: [],
      userSelected: ""
    };
  },

  components: {
    Header,
    TakeAppointment,
    ReserveAppointment,
    SignUp,
    EditAppointment,
    HomePage,
    Footer
  },

  created() {
    this.callApiuser1();
  },

  methods: {
    /* async callApiuser1() {
      const result = await fetch(this.URL1);
      const data = await result.json();
      this.arrayuser1 = data;
    }, */
    async callApiuser1() {
   api.callApiuser1()
    },

    takeappointment() {
      this.screenHome = false;
      this.screen = "TakeAppointment";
    },

    registrarme() {
      this.screen = "SignUp";
      console.log("moha");
    },
    /*  validemail() {
      this.screen = "ReserveAppointment";
      console.log("moha");
    }, */
    async reservenewmappointment(date, description, starttime, endtime) {
      api.reservenewmappointment(date, description, starttime, endtime)
    },
    async singing(username, email, password, validaRepetirPassword) {
      if (
        username == null ||
        email == null ||
        password == null ||
        validaRepetirPassword == null
      ) {
        alert("Escribir informacion");
      } else {
        await fetch(this.URL2, {
          method: "POST",
          headers: {
            "Content-Type": "application/json"
          },
          body: JSON.stringify({
            username: username,
            email: email,
            password: password,
            validaRepetirPassword: validaRepetirPassword
          })
        })
          .then(response => response.json())
          .catch(error => console.error("Error:", error))
          .then(response => console.log("Success:", response));
        alert("welcom to Peñascal barbershop");
        this.takeappointment();
      }
    },
    validemail(email, password) {
      if (email == null || password == null) {
        alert("Enter the email and password!");
      } else {
        this.screen = "ReserveAppointment";
        console.log("hola3");
      }
    },
    async deleteUser(id) {
      console.log("ID");
      this.userId = id;
      this.completeURL = this.URL1 + "/" + this.userId;
      await this.deleteUser1();
      await this.callApiuser1();
      console.log("7777");
    },
    async deleteUser1() {
      await fetch(this.completeURL, {
        method: "Delete"
      }).then(response => response.json());
    },
    editUser(user1) {
      this.userSelected = user1;
      this.screen = "EditAppointment";
      this.action = "editar";
    },

      async confermeditUser(user1) {
      const urlz = this.URL1 + "/" + user1.id;
      console.log(urlz) + "jjjjjjjj";
      await fetch(this.URL1 + "/" + user1.id, {
        method: "PUT",
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({
              date: user1.date,
            description: user1.description,
            starttime: user1.starttime,
            endtime: user1.endtime,
            id:user1.id
        })
      }).then(response => response.json());
       this.screen = "ReserveAppointment";
    }, 
  }
};
</script>

<style></style>
